package net.roseindia.searchengine.dao;

import java.util.*;
import java.text.*;
import java.util.ArrayList;
import java.util.Collection;
import java.sql.*;

import org.hibernate.*;
import org.hibernate.cfg.*;

import javax.persistence.Persistence;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import javax.persistence.PersistenceException;

import org.springframework.orm.jpa.vendor.HibernateJpaDialect;
import org.springframework.transaction.annotation.Transactional;

//Mail imports
import javax.mail.Message;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.URLName;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;
import com.sun.mail.smtp.SMTPTransport;
import javax.mail.*;
import javax.mail.internet.*;

import net.roseindia.searchengine.model.*;

import org.hibernate.search.jpa.Search;
import org.hibernate.search.jpa.FullTextEntityManager;
import org.hibernate.search.jpa.FullTextQuery;
import org.hibernate.search.FullTextFilter;


import org.apache.lucene.index.Term;

import org.apache.lucene.queryParser.QueryParser;
import org.apache.lucene.queryParser.*;

import org.apache.lucene.analysis.StopAnalyzer;
import org.apache.lucene.analysis.Analyzer.*;
import org.apache.lucene.analysis.SimpleAnalyzer;
import org.apache.lucene.analysis.KeywordAnalyzer;
import org.apache.lucene.analysis.standard.StandardAnalyzer;
import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.analysis.TokenStream;



import org.apache.lucene.search.*;
import org.apache.lucene.search.highlight.*;
import org.apache.lucene.search.highlight.Highlighter;
import org.apache.lucene.search.highlight.QueryScorer;
import org.apache.lucene.search.highlight.SimpleFragmenter;
import org.apache.lucene.search.highlight.SimpleHTMLFormatter;


import org.springframework.orm.jpa.JpaCallback;
import org.springframework.orm.jpa.JpaTemplate;

import java.io.StringReader;



@Transactional
public class SearchDaoImpl implements SearchDao {

  

 private EntityManager em;
 Session session = null;
 JpaTemplate jpaTemplate;
 int totalCount;


    @PersistenceContext
    public void setEntityManager(EntityManager em) {
        this.em = em;
    }

	public void save(Webpages webpages) {
		try
		{
		em.persist(webpages);
		}
		catch (Exception e)
		{
		//System.out.println("SQLException exception is :"+e.getMessage());
		}

		FullTextEntityManager fullTextEntityManager = Search.createFullTextEntityManager(em);
		fullTextEntityManager.index(webpages);
	}
	 

	public JpaTemplate getJpaTemplate() {
		return jpaTemplate;
	}

	public void setJpaTemplate(JpaTemplate jpaTemplate) {
		this.jpaTemplate = jpaTemplate;
	}

	public Webpages getApplicant(int id) {
		return getJpaTemplate().find(Webpages.class, id);
	}


public Paging searchPageObj(final String title,int startIndex,int offset){

	Paging paging = new Paging();

	List resultList = null;
	List resultList1 = null;

	FullTextEntityManager fullTextEntityManager = Search.createFullTextEntityManager(em);
	Analyzer analyzer = new StandardAnalyzer();
	int totalsize=0;
	try{
		String[] fields={"pageContent","url","title"};

		QueryParser parser = new MultiFieldQueryParser(fields, new StandardAnalyzer()); 
		org.apache.lucene.search.Query luceneQuery = parser.parse( title );

	    org.hibernate.search.jpa.FullTextQuery fullTextQuery = fullTextEntityManager.createFullTextQuery( luceneQuery );

		totalsize =  fullTextQuery.getResultSize();

		fullTextQuery.setFirstResult(startIndex);
		fullTextQuery.setMaxResults(offset);

		resultList  = fullTextQuery.getResultList(); 

		SimpleHTMLFormatter sHtmlF = new SimpleHTMLFormatter("<font color='#ff0000'><b><span style='background-color:yellow'>", "</span></b></font>");
		Highlighter highlight = new Highlighter(sHtmlF, new QueryScorer(luceneQuery));
		highlight.setTextFragmenter(new SimpleFragmenter(300));
		for (Object result : resultList) {
			Webpages doc = (Webpages) result;
			String content = doc.getPageContent();
			String doctitle = doc.getTitle();
			TokenStream stream = analyzer.tokenStream("pageContent",new StringReader(content));
			String summary = highlight.getBestFragments(stream, content,3, "...");
    		doc.setPageContent(summary);
	    }
	}
	catch(Exception e){
//	System.out.println(e);
	}


	paging.setTotalCount(totalsize);
	paging.setSearchList(resultList);


	return paging;
}
	 
}

