package net.roseindia.searchengine.model;

import java.util.*;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.*;
import org.hibernate.search.annotations.*;

@Entity
@Table(name = "webpages")
@Indexed
@Analyzer(impl = org.apache.lucene.analysis.standard.StandardAnalyzer.class)

public class Webpages {

	private int id;
	@Field(index=Index.TOKENIZED)
	private String title;
	
	@Field(index=Index.TOKENIZED)
	private String url;

	@Field(index=Index.TOKENIZED)
	private String pageContent;

	
	@Id
	@GeneratedValue
    @DocumentId
    public int getId(){
		return id;
	}
	
	public void setId(int id) {
		this.id = id;
	}

	@Column(name = "title", updatable = false, nullable = true, insertable = true)
    public String getTitle() {
		return title;
	}

	public void setTitle(String title) {
		this.title = title;
	}


    @Column(name = "url", updatable = false, nullable = true, insertable = true)
    public String getUrl() {
		return url;
	}

	public void setUrl(String url) {
		this.url = url;
	}

	@Column(name = "pageContent", updatable = false, nullable = true, insertable = true)
    public String getPageContent() {
		return pageContent;
	}

	public void setPageContent(String pageContent) {
		this.pageContent = pageContent;
	}

}